<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-public](./kibana-plugin-core-public.md) &gt; [AppBase](./kibana-plugin-core-public.appbase.md) &gt; [updater$](./kibana-plugin-core-public.appbase.updater_.md)

## AppBase.updater$ property

An [AppUpdater](./kibana-plugin-core-public.appupdater.md) observable that can be used to update the application [AppUpdatableFields](./kibana-plugin-core-public.appupdatablefields.md) at runtime.

<b>Signature:</b>

```typescript
updater$?: Observable<AppUpdater>;
```

## Example

How to update an application navLink at runtime

```ts
// inside your plugin's setup function
export class MyPlugin implements Plugin {
  private appUpdater = new BehaviorSubject<AppUpdater>(() => ({}));

  setup({ application }) {
    application.register({
      id: 'my-app',
      title: 'My App',
      updater$: this.appUpdater,
      async mount(params) {
        const { renderApp } = await import('./application');
        return renderApp(params);
      },
    });
  }

  start() {
     // later, when the navlink needs to be updated
     appUpdater.next(() => {
       navLinkStatus: AppNavLinkStatus.disabled,
     })
  }

```

