<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-public](./kibana-plugin-core-public.md) &gt; [AppMountParameters](./kibana-plugin-core-public.appmountparameters.md) &gt; [appBasePath](./kibana-plugin-core-public.appmountparameters.appbasepath.md)

## AppMountParameters.appBasePath property

> Warning: This API is now obsolete.
> 
> Use [AppMountParameters.history](./kibana-plugin-core-public.appmountparameters.history.md) instead.
> 

The route path for configuring navigation to the application. This string should not include the base path from HTTP.

<b>Signature:</b>

```typescript
appBasePath: string;
```

## Example

How to configure react-router with a base path:

```ts
// inside your plugin's setup function
export class MyPlugin implements Plugin {
  setup({ application }) {
    application.register({
     id: 'my-app',
     appRoute: '/my-app',
     async mount(params) {
       const { renderApp } = await import('./application');
       return renderApp(params);
     },
   });
 }
}

```

```ts
// application.tsx
import React from 'react';
import ReactDOM from 'react-dom';
import { BrowserRouter, Route } from 'react-router-dom';

import { CoreStart, AppMountParameters } from 'src/core/public';
import { MyPluginDepsStart } from './plugin';

export renderApp = ({ appBasePath, element }: AppMountParameters) => {
  ReactDOM.render(
    // pass `appBasePath` to `basename`
    <BrowserRouter basename={appBasePath}>
      <Route path="/" exact component={HomePage} />
    </BrowserRouter>,
    element
  );

  return () => ReactDOM.unmountComponentAtNode(element);
}

```

