<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-public](./kibana-plugin-core-public.md) &gt; [AppMountParameters](./kibana-plugin-core-public.appmountparameters.md) &gt; [history](./kibana-plugin-core-public.appmountparameters.history.md)

## AppMountParameters.history property

A scoped history instance for your application. Should be used to wire up your applications Router.

<b>Signature:</b>

```typescript
history: ScopedHistory<HistoryLocationState>;
```

## Example

How to configure react-router with a base path:

```ts
// inside your plugin's setup function
export class MyPlugin implements Plugin {
  setup({ application }) {
    application.register({
     id: 'my-app',
     appRoute: '/my-app',
     async mount(params) {
       const { renderApp } = await import('./application');
       return renderApp(params);
     },
   });
 }
}

```

```ts
// application.tsx
import React from 'react';
import ReactDOM from 'react-dom';
import { Router, Route } from 'react-router-dom';

import { CoreStart, AppMountParameters } from 'src/core/public';
import { MyPluginDepsStart } from './plugin';

export renderApp = ({ element, history }: AppMountParameters) => {
  ReactDOM.render(
    <Router history={history}>
      <Route path="/" exact component={HomePage} />
    </Router>,
    element
  );

  return () => ReactDOM.unmountComponentAtNode(element);
}

```

