<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-public](./kibana-plugin-core-public.md) &gt; [AppMountParameters](./kibana-plugin-core-public.appmountparameters.md) &gt; [onAppLeave](./kibana-plugin-core-public.appmountparameters.onappleave.md)

## AppMountParameters.onAppLeave property

A function that can be used to register a handler that will be called when the user is leaving the current application, allowing to prompt a confirmation message before actually changing the page.

This will be called either when the user goes to another application, or when trying to close the tab or manually changing the url.

<b>Signature:</b>

```typescript
onAppLeave: (handler: AppLeaveHandler) => void;
```

## Example


```ts
// application.tsx
import React from 'react';
import ReactDOM from 'react-dom';
import { BrowserRouter, Route } from 'react-router-dom';

import { CoreStart, AppMountParams } from 'src/core/public';
import { MyPluginDepsStart } from './plugin';

export renderApp = ({ element, history, onAppLeave }: AppMountParams) => {
   const { renderApp, hasUnsavedChanges } = await import('./application');
   onAppLeave(actions => {
     if(hasUnsavedChanges()) {
       return actions.confirm('Some changes were not saved. Are you sure you want to leave?');
     }
     return actions.default();
   });
   return renderApp({ element, history });
}

```

