<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [CapabilitiesSetup](./kibana-plugin-core-server.capabilitiessetup.md)

## CapabilitiesSetup interface

APIs to manage the [Capabilities](./kibana-plugin-core-server.capabilities.md) that will be used by the application.

Plugins relying on capabilities to toggle some of their features should register them during the setup phase using the `registerProvider` method.

Plugins having the responsibility to restrict capabilities depending on a given context should register their capabilities switcher using the `registerSwitcher` method.

Refers to the methods documentation for complete description and examples.

<b>Signature:</b>

```typescript
export interface CapabilitiesSetup 
```

## Methods

|  Method | Description |
|  --- | --- |
|  [registerProvider(provider)](./kibana-plugin-core-server.capabilitiessetup.registerprovider.md) | Register a [CapabilitiesProvider](./kibana-plugin-core-server.capabilitiesprovider.md) to be used to provide [Capabilities](./kibana-plugin-core-server.capabilities.md) when resolving them. |
|  [registerSwitcher(switcher)](./kibana-plugin-core-server.capabilitiessetup.registerswitcher.md) | Register a [CapabilitiesSwitcher](./kibana-plugin-core-server.capabilitiesswitcher.md) to be used to change the default state of the [Capabilities](./kibana-plugin-core-server.capabilities.md) entries when resolving them.<!-- -->A capabilities switcher can only change the state of existing capabilities. Capabilities added or removed when invoking the switcher will be ignored. |

