<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [CapabilitiesSetup](./kibana-plugin-core-server.capabilitiessetup.md) &gt; [registerSwitcher](./kibana-plugin-core-server.capabilitiessetup.registerswitcher.md)

## CapabilitiesSetup.registerSwitcher() method

Register a [CapabilitiesSwitcher](./kibana-plugin-core-server.capabilitiesswitcher.md) to be used to change the default state of the [Capabilities](./kibana-plugin-core-server.capabilities.md) entries when resolving them.

A capabilities switcher can only change the state of existing capabilities. Capabilities added or removed when invoking the switcher will be ignored.

<b>Signature:</b>

```typescript
registerSwitcher(switcher: CapabilitiesSwitcher): void;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  switcher | <code>CapabilitiesSwitcher</code> |  |

<b>Returns:</b>

`void`

## Example

How to restrict some capabilities

```ts
// my-plugin/server/plugin.ts
public setup(core: CoreSetup, deps: {}) {
   core.capabilities.registerSwitcher((request, capabilities) => {
     if(myPluginApi.shouldRestrictSomePluginBecauseOf(request)) {
       return {
         somePlugin: {
           featureEnabledByDefault: false // `featureEnabledByDefault` will be disabled. All other capabilities will remain unchanged.
         }
       }
     }
     return {}; // All capabilities will remain unchanged.
   });
}

```

