<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [RouteValidationFunction](./kibana-plugin-core-server.routevalidationfunction.md)

## RouteValidationFunction type

The custom validation function if @<!-- -->kbn/config-schema is not a valid solution for your specific plugin requirements.

<b>Signature:</b>

```typescript
export declare type RouteValidationFunction<T> = (data: any, validationResult: RouteValidationResultFactory) => {
    value: T;
    error?: never;
} | {
    value?: never;
    error: RouteValidationError;
};
```

## Example

The validation should look something like:

```typescript
interface MyExpectedBody {
  bar: string;
  baz: number;
}

const myBodyValidation: RouteValidationFunction<MyExpectedBody> = (data, validationResult) => {
  const { ok, badRequest } = validationResult;
  const { bar, baz } = data || {};
  if (typeof bar === 'string' && typeof baz === 'number') {
    return ok({ bar, baz });
  } else {
    return badRequest('Wrong payload', ['body']);
  }
}

```

