<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-core-server](./kibana-plugin-core-server.md) &gt; [SessionStorageCookieOptions](./kibana-plugin-core-server.sessionstoragecookieoptions.md)

## SessionStorageCookieOptions interface

Configuration used to create HTTP session storage based on top of cookie mechanism.

<b>Signature:</b>

```typescript
export interface SessionStorageCookieOptions<T> 
```

## Properties

|  Property | Type | Description |
|  --- | --- | --- |
|  [encryptionKey](./kibana-plugin-core-server.sessionstoragecookieoptions.encryptionkey.md) | <code>string</code> | A key used to encrypt a cookie's value. Should be at least 32 characters long. |
|  [isSecure](./kibana-plugin-core-server.sessionstoragecookieoptions.issecure.md) | <code>boolean</code> | Flag indicating whether the cookie should be sent only via a secure connection. |
|  [name](./kibana-plugin-core-server.sessionstoragecookieoptions.name.md) | <code>string</code> | Name of the session cookie. |
|  [sameSite](./kibana-plugin-core-server.sessionstoragecookieoptions.samesite.md) | <code>'Strict' &#124; 'Lax' &#124; 'None'</code> | Defines SameSite attribute of the Set-Cookie Header. https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite |
|  [validate](./kibana-plugin-core-server.sessionstoragecookieoptions.validate.md) | <code>(sessionValue: T &#124; T[]) =&gt; SessionCookieValidationResult</code> | Function called to validate a cookie's decrypted value. |

